﻿using Telerik.Windows.Controls;
using System.ComponentModel;
using Telerik.Windows.Data;
using System.Collections.Generic;

namespace HierarchicalGridViewSerialization
{
    public class ColumnProxy
    {
        public string UniqueName { get; set; }
        public int DisplayOrder { get; set; }
        public object Header { get; set; }
        public GridViewLength Width { get; set; }
        public bool IsSelectColumn { get; set; }
    }

    public class SelectedIdProxy
    {
        public int SelectedId { get; set; }
    }

    public class SortDescriptorProxy
    {
        public string ColumnUniqueName { get; set; }
        public ListSortDirection SortDirection { get; set; }
    }

    public class GroupDescriptorProxy
    {
        public string ColumnUniqueName { get; set; }
        public ListSortDirection? SortDirection { get; set; }
    }

    public class FilterDescriptorProxy
    {
        public string Member { get; set; }
        public FilterOperator Operator { get; set; }
        public object Value { get; set; }
        public bool IsCaseSensitive { get; set; }

    }

    public class FilterSetting
    {
        public string PropertyName { get; set; }
        public string ColumnUniqueName { get; set; }
        	
       private List<object> _SelectedDistinctValues;

       public List<object> SelectedDistinctValues
       {
           get
           {
               if (_SelectedDistinctValues == null)
               {
                   _SelectedDistinctValues = new List<object>();
               }
               return _SelectedDistinctValues;
           }
       }

        FilterDescriptorProxy _Filter1;
        public FilterDescriptorProxy Filter1
        {
            get
            {
                return _Filter1;
            }
            set
            {
                _Filter1 = value;
            }
        }

        FilterDescriptorProxy _Filter2;
        public FilterDescriptorProxy Filter2
        {
            get
            {
                return _Filter2;
            }
            set
            {
                _Filter2 = value;
            }
        }
    }
}
